stages:
  - compiling
  - running
  - running_smoke


.rule:
  rules:
    ## run always, if on master branch
    - if: $PARENT_PIPELINE_COMMIT_BRANCH == $PARENT_PIPELINE_DEFAULT_BRANCH
    ## run always for selected (current) version
    - if: $IMAGETAG == $CI_IMAGE
    ## else: can start manual
    - when: manual


compile:
  stage: compiling
  rules:
    !reference [.rule, rules]
  allow_failure:
    exit_codes: 42
  before_script: []
  script:
    - echo "I compile the code and will return 42 in case of compilation warnings"
    - echo $CI_IMAGE
    - exit 42
  artifacts:
    when: always
    paths:
    - log.*


run_1min_test:
  stage: running
  rules:
    !reference [.rule, rules]
  script:
    - echo "I need artifacts from the compile-job"


run_30min_test:
  stage: running_smoke
  needs:
    - run_1min_test
  script:
    - echo "I need artifacts from the compile-job and am bigger (and more optional) than the previuos test-job"
